#[derive(Debug, Clone, Copy, PartialEq, Eq)]
pub enum Instruction {
    /// Call a function on top of the stack
    /// with n arguments
    Call(usize),

    /// Unconditional jump by offset
    Jump(isize),

    /// Jump by offset if value on
    /// top of the stack is falsey (nil)
    JumpN(isize),

    /// Load a value from constants table
    LdConst(usize),

    /// Load a value from locals table
    LdLocal(usize),

    /// Store a value to locals table
    StLocal(usize),

    /// Drop a value from stack
    Drop,

    /// Duplicate value on stack
    Dup,
}
